SystemOrganization addCategory: #'GT-Debugger-EventRecorder'!

!GTGoAndInspectBytecodeDebugAction methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/18/2016 15:52'!
asRecorderEvent

	^ GTDebuggerRecorderGoAndInspectBytecodeEvent fromDebugAction: self! !

!GTStepToBytecodeDebugAction methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/18/2016 15:52'!
asRecorderEvent

	^ GTDebuggerRecorderStepToBytecodeEvent fromDebugAction: self! !

!GTGenericStackDebuggerSelectionChanged methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/18/2016 15:44'!
asRecorderEvent

	^ GTDebuggerRecorderStackSelectionChangedEvent fromAnnouncement: self! !

!DebugAction methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/18/2016 15:43'!
asRecorderEvent

	^ GTDebuggerRecorderDebugActionEvent fromDebugAction: self! !

!RunToSelectionDebugAction methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/18/2016 15:52'!
asRecorderEvent

	^ GTDebuggerRecorderRunToSelectionEvent fromDebugAction: self! !

!GLMBrowserClosing methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/18/2016 15:45'!
asRecorderEvent

	^ GTDebuggerRecorderClosingEvent fromAnnouncement: self! !

!GTChangeDebuggerAction methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/18/2016 15:48'!
asRecorderEvent

	^ GTDebuggerRecorderChangeDebuggerEvent fromDebugAction: self! !

!GTGlamourWrapperDebuggingAction methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/18/2016 15:52'!
asRecorderEvent

	^ GTDebuggerRecorderGlamourWrapperEvent fromDebugAction: self! !

GTEventCollector subclass: #GTDebuggerEventCollector
	instanceVariableNames: 'announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder'!

!GTDebuggerEventCollector methodsFor: 'initialization' stamp: 'RogerStebler 3/1/2016 18:41'!
initialize
	super initialize.	
	recordedEvents := SharedQueue  new.! !

!GTDebuggerEventCollector methodsFor: 'initialization' stamp: 'AndreiChis 1/29/2016 14:16'!
linkToDebugger: aDebugger

	aDebugger announcer weak when: Announcement send: #recordAnnouncement: to: self! !

!GTDebuggerEventCollector methodsFor: 'events' stamp: 'RogerStebler 3/18/2016 15:46'!
recordAnnouncement: anAnnouncement
	| event |
	Privacy sendDiagnosticsAndUsageData ifFalse: [ ^ self ].
	(anAnnouncement respondsTo: #asRecorderEvent) ifTrue: [	
		event := anAnnouncement asRecorderEvent.
		self add: event.
		GTEventRecorder uniqueInstance announcer announce: (GTDebuggerRecorderEventRecorded forEvent: event). ]! !

!GTDebuggerEventCollector methodsFor: 'events' stamp: 'RogerStebler 3/18/2016 15:46'!
recordDebuggerOpenEventFor: aDebugger
	| event |
	Privacy sendDiagnosticsAndUsageData ifFalse: [ ^ self ].
	event := GTDebuggerRecorderOpenEvent new fromDebugger: aDebugger.
	self add: event.
	GTEventRecorder uniqueInstance announcer announce: (GTDebuggerRecorderEventRecorded forEvent: event).! !

Announcement subclass: #GTDebuggerRecorderEventRecorded
	instanceVariableNames: 'recordedEvent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder'!

!GTDebuggerRecorderEventRecorded class methodsFor: 'instance creation' stamp: 'RogerStebler 3/1/2016 17:48'!
forEvent: aRecorderEvent
	^ self new
		recordedEvent: aRecorderEvent;
		yourself.! !

!GTDebuggerRecorderEventRecorded methodsFor: 'accessing' stamp: 'RogerStebler 3/1/2016 17:50'!
recordedEvent
	^ recordedEvent! !

!GTDebuggerRecorderEventRecorded methodsFor: 'accessing' stamp: 'RogerStebler 3/1/2016 17:50'!
recordedEvent: aRecorderEvent
	recordedEvent := aRecorderEvent! !

!GTRunToSelectionDebugAction methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/18/2016 15:52'!
asRecorderEvent

	^ GTDebuggerRecorderGTRunToSelectionEvent fromDebugAction: self! !

!MessageSendDebugAction methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/18/2016 15:52'!
asRecorderEvent

	^ GTDebuggerRecorderMessageSendEvent fromDebugAction: self! !

!DebugActionExecuted methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/11/2016 13:54'!
asRecorderEvent

	^ (debuggingAction asRecorderEvent fromAnnouncement: self)
		isExecuted: true;
		yourself! !

Object subclass: #GTDebuggerRecorderEvent
	instanceVariableNames: 'timestamp info'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder'!

GTDebuggerRecorderEvent subclass: #GTDebuggerRecorderClosingEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder'!

!GTDebuggerRecorderClosingEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/15/2016 16:10'!
fromAnnouncement: anAnnouncement
	super fromAnnouncement: anAnnouncement.
	
	self addWindowHashFor: anAnnouncement presentation.! !

GTDebuggerRecorderEvent subclass: #GTDebuggerRecorderDebugActionEvent
	instanceVariableNames: 'isExecuted'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder'!

GTDebuggerRecorderDebugActionEvent subclass: #GTDebuggerRecorderChangeDebuggerEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder'!

!GTDebuggerRecorderChangeDebuggerEvent methodsFor: 'private' stamp: 'RogerStebler 3/5/2016 16:02'!
addNewWindowHashFor: aPresentation

	aPresentation window ifNotNil: [ :aWindow |
		self infoAt: #newWindowHash put: aWindow identityHash ]! !

!GTDebuggerRecorderChangeDebuggerEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/11/2016 14:05'!
fromDebugAction: aDebugAction
	super fromDebugAction: aDebugAction.
	aDebugAction newDebugger isNotNil ifTrue: [ self addNewWindowHashFor: aDebugAction newDebugger ]! !

GTDebuggerRecorderDebugActionEvent subclass: #GTDebuggerRecorderCodeDebugActionEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder'!

!GTDebuggerRecorderCodeDebugActionEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/12/2016 14:40'!
fromDebugAction: aDebugAction
	super fromDebugAction: aDebugAction.
	self infoAt: #selection put: aDebugAction debugger selectionInterval.! !

!GTDebuggerRecorderDebugActionEvent class methodsFor: 'instance creation' stamp: 'RogerStebler 3/15/2016 15:52'!
fromDebugAction: aDebugAction

	^ self new fromDebugAction: aDebugAction! !

!GTDebuggerRecorderDebugActionEvent methodsFor: 'accessing' stamp: 'RogerStebler 3/9/2016 14:34'!
= otherGTDebuggerDebugActionEvent
	(otherGTDebuggerDebugActionEvent isKindOf: self class) ifFalse: [ ^ false ].
	(self infoAt: #debugActionClass) == (otherGTDebuggerDebugActionEvent infoAt: #debugActionClass) ifFalse: [ ^ false ].
	(self infoAt: #methodClass) == (otherGTDebuggerDebugActionEvent infoAt: #methodClass) ifFalse: [ ^ false ].
	(self infoAt: #methodSelector) == (otherGTDebuggerDebugActionEvent infoAt: #methodSelector) ifFalse: [ ^ false ].
	(self infoAt: #pc) == (otherGTDebuggerDebugActionEvent infoAt: #pc) ifFalse: [ ^ false ].
	(self infoAt: #windowHash) == (otherGTDebuggerDebugActionEvent infoAt: #windowHash) ifFalse: [ ^ false ].
	^ true! !

!GTDebuggerRecorderDebugActionEvent methodsFor: 'accessing' stamp: 'RogerStebler 2/29/2016 15:11'!
asDebugActionFor: aDebugger
	| actionClass |
	actionClass := (info at: #debugActionClass) asSymbol asClass.
	(actionClass respondsTo: #gtGlobalDebuggingActionFor:) ifTrue: [
		^ actionClass gtGlobalDebuggingActionFor: aDebugger ].
	^ nil! !

!GTDebuggerRecorderDebugActionEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/17/2016 16:45'!
fromDebugAction: aDebugAction
	self infoAt: #debugActionClass put: aDebugAction class name.
	self infoAt: #methodClass putHashForText: aDebugAction currentContext methodClass name.
	self infoAt: #methodSelector putHashForText: aDebugAction currentContext methodSelector.
	self infoAt: #pc put: aDebugAction currentContext pc.
	self addWindowHashFor: aDebugAction debugger.! !

!GTDebuggerRecorderDebugActionEvent methodsFor: 'testing' stamp: 'RogerStebler 3/5/2016 15:17'!
isAboutToExectute
	^ self isExecuted not! !

!GTDebuggerRecorderDebugActionEvent methodsFor: 'testing' stamp: 'RogerStebler 3/4/2016 14:58'!
isActionForClass: aClassName Method: aMethodName PC: anInteger
	((self infoAt: #methodClass) == aClassName) ifFalse: [ ^ false ].
	((self infoAt: #methodSelector) == aMethodName) ifFalse: [ ^ false ].
	((self infoAt: #pc) == anInteger) ifFalse: [ ^ false ].
	^ true.! !

!GTDebuggerRecorderDebugActionEvent methodsFor: 'testing' stamp: 'RogerStebler 3/7/2016 16:25'!
isActionForContext: aContext
	^ self isActionForClass: aContext methodClass name Method: aContext methodSelector PC: aContext pc.! !

!GTDebuggerRecorderDebugActionEvent methodsFor: 'testing' stamp: 'RogerStebler 3/11/2016 13:53'!
isExecuted
	^ isExecuted! !

!GTDebuggerRecorderDebugActionEvent methodsFor: 'testing' stamp: 'RogerStebler 3/11/2016 13:53'!
isExecuted: aBoolean
	isExecuted := aBoolean! !

GTDebuggerRecorderDebugActionEvent subclass: #GTDebuggerRecorderGTRunToSelectionEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder'!

!GTDebuggerRecorderGTRunToSelectionEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/11/2016 18:44'!
fromDebugAction: aDebugAction
	super fromDebugAction: aDebugAction.
	self infoAt: #selection put: aDebugAction debugger selectionInterval.! !

GTDebuggerRecorderDebugActionEvent subclass: #GTDebuggerRecorderGlamourWrapperEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder'!

!GTDebuggerRecorderGlamourWrapperEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/11/2016 17:54'!
fromDebugAction: aDebugAction
	self flag: 'Find a better way to get type of action'.
	super fromDebugAction: aDebugAction.
	self infoAt: #glamourActionTitle put: aDebugAction asGlamourAction title.! !

GTDebuggerRecorderDebugActionEvent subclass: #GTDebuggerRecorderGoAndInspectBytecodeEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder'!

!GTDebuggerRecorderGoAndInspectBytecodeEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/12/2016 14:50'!
fromDebugAction: aDebugAction
	super fromDebugAction: aDebugAction.
	self infoAt: #selection put: aDebugAction debugger bytecodePresentation selection.! !

GTDebuggerRecorderDebugActionEvent subclass: #GTDebuggerRecorderMessageSendEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder'!

!GTDebuggerRecorderMessageSendEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/11/2016 18:24'!
fromDebugAction: aDebugAction
	super fromDebugAction: aDebugAction.
	self infoAt: #selector put: aDebugAction selector.! !

GTDebuggerRecorderDebugActionEvent subclass: #GTDebuggerRecorderRunToSelectionEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder'!

!GTDebuggerRecorderRunToSelectionEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/11/2016 18:44'!
fromDebugAction: aDebugAction
	super fromDebugAction: aDebugAction.
	self infoAt: #selection put: aDebugAction debugger code getSelection.! !

GTDebuggerRecorderDebugActionEvent subclass: #GTDebuggerRecorderStepToBytecodeEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder'!

!GTDebuggerRecorderStepToBytecodeEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/12/2016 14:50'!
fromDebugAction: aDebugAction
	super fromDebugAction: aDebugAction.
	self infoAt: #selection put: aDebugAction debugger bytecodePresentation selection.! !

!GTDebuggerRecorderEvent class methodsFor: 'instance creation' stamp: 'AndreiChis 1/29/2016 14:28'!
fromAnnouncement: anAnnouncement

	^ self new fromAnnouncement: anAnnouncement! !

!GTDebuggerRecorderEvent methodsFor: 'accessing' stamp: 'AndreiChis 1/29/2016 15:36'!
addWindowHashFor: aPresentation

	aPresentation window ifNotNil: [ :aWindow |
		self infoAt: #windowHash put: aWindow identityHash ]! !

!GTDebuggerRecorderEvent methodsFor: 'initialization' stamp: 'AndreiChis 1/29/2016 14:28'!
fromAnnouncement: anAnnouncement
! !

!GTDebuggerRecorderEvent methodsFor: 'accessing' stamp: 'RogerStebler 3/17/2016 16:42'!
hashForText: aString
	^ self settings obfuscateIfNecessary: aString! !

!GTDebuggerRecorderEvent methodsFor: 'accessing' stamp: 'RogerStebler 3/3/2016 17:21'!
infoAt: aSymbol
	^ info at: aSymbol! !

!GTDebuggerRecorderEvent methodsFor: 'accessing' stamp: 'RogerStebler 3/17/2016 17:23'!
infoAt: key ifAbsent: absentBlock
	info ifNil: [ ^ absentBlock value].
	^ info at: key ifAbsent: absentBlock! !

!GTDebuggerRecorderEvent methodsFor: 'accessing' stamp: 'RogerStebler 3/17/2016 17:23'!
infoAt: key ifAbsentPut: putBlock
	info ifNil: [ info := Dictionary new ].
	^ info at: key ifAbsentPut: putBlock! !

!GTDebuggerRecorderEvent methodsFor: 'accessing' stamp: 'RogerStebler 3/17/2016 17:23'!
infoAt: key ifPresent: presentBlock ifAbsent: absentBlock
	info ifNil: [ ^ absentBlock value].
	^ info at: key ifPresent: presentBlock ifAbsent: absentBlock! !

!GTDebuggerRecorderEvent methodsFor: 'accessing' stamp: 'AndreiChis 1/29/2016 14:42'!
infoAt: key put: value
	info ifNil: [ info := Dictionary new ].
	^ info at: key put: value! !

!GTDebuggerRecorderEvent methodsFor: 'accessing' stamp: 'RogerStebler 3/17/2016 16:43'!
infoAt: key putHashForText: valueString 
	^ self 
		infoAt: key 
		put: (self hashForText: valueString)! !

!GTDebuggerRecorderEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/10/2016 18:04'!
initialize
	super initialize.
	timestamp := DateAndTime now.! !

!GTDebuggerRecorderEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/17/2016 16:16'!
initializeObfuscated
	self obfuscated: Privacy sendEntityNames not.! !

!GTDebuggerRecorderEvent methodsFor: 'accessing' stamp: 'RogerStebler 3/17/2016 16:15'!
obfuscated
	^ self infoAt: #obfuscated ifAbsent: true! !

!GTDebuggerRecorderEvent methodsFor: 'accessing' stamp: 'RogerStebler 3/17/2016 16:15'!
obfuscated: aBoolean
	^ self infoAt: #obfuscated put: aBoolean! !

!GTDebuggerRecorderEvent methodsFor: 'accessing' stamp: 'RogerStebler 3/17/2016 16:51'!
settings
	^ GlobalIdentifier uniqueInstance! !

!GTDebuggerRecorderEvent methodsFor: 'accessing' stamp: 'RogerStebler 3/10/2016 18:05'!
timestamp
	^ timestamp! !

GTDebuggerRecorderEvent subclass: #GTDebuggerRecorderOpenEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder'!

!GTDebuggerRecorderOpenEvent class methodsFor: 'instance creation' stamp: 'RogerStebler 3/15/2016 15:49'!
fromDebugger: aDebugger

	^ self new fromDebugger: aDebugger! !

!GTDebuggerRecorderOpenEvent methodsFor: 'initialization' stamp: 'AndreiChis 1/29/2016 15:37'!
fromDebugger: aDebugger

	self infoAt: #debuggerClass put: aDebugger class name.
	self addWindowHashFor: aDebugger! !

!GTDebuggerRecorderOpenEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/17/2016 16:48'!
initialize
	super initialize.
	self initializeObfuscated.! !

GTDebuggerRecorderEvent subclass: #GTDebuggerRecorderStackSelectionChangedEvent
	instanceVariableNames: 'debugger newContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-EventRecorder'!

!GTDebuggerRecorderStackSelectionChangedEvent methodsFor: 'initialization' stamp: 'RogerStebler 3/17/2016 16:45'!
fromAnnouncement: anAnnouncement
	super fromAnnouncement: anAnnouncement.
	
	self infoAt: #newContext putHashForText: anAnnouncement newContext asString.
	self addWindowHashFor: anAnnouncement debugger.! !

!GTCodeDebugAction methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/18/2016 15:47'!
asRecorderEvent

	^ GTDebuggerRecorderCodeDebugActionEvent fromDebugAction: self! !

!DebugActionAboutToExecute methodsFor: '*GT-Debugger-EventRecorder' stamp: 'RogerStebler 3/11/2016 13:54'!
asRecorderEvent

	^ (debuggingAction asRecorderEvent fromAnnouncement: self)
		isExecuted: false;
		yourself! !
